<?php
  
  function LivelyChatSupport_installation(){
    global $wpdb;
    $convos_table = $wpdb->prefix . "livelychatsupport_convos";
    $messages_table = $wpdb->prefix . "livelychatsupport_messages";
    $agents_table = $wpdb->prefix . "livelychatsupport_agents";

    $sql = "CREATE TABLE $convos_table (
      token VARCHAR(32) NOT NULL,
      name VARCHAR(50),
      email VARCHAR(100),
      pending boolean DEFAULT 1 NOT NULL,
      messages_count mediumint(9) DEFAULT 0 NOT NULL,
      ip VARCHAR(15),
      user_agent text,
      city VARCHAR(15),
      province VARCHAR(15),
      country VARCHAR(15),
      country_code VARCHAR(15),
      province_code VARCHAR(15),
      latitude VARCHAR(15),
      longitude VARCHAR(15),
      referrers text NOT NULL,
      last_seen datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
      created_at datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
      updated_at datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
      PRIMARY KEY (token)
    );
    CREATE TABLE $messages_table (
      id mediumint(9) NOT NULL AUTO_INCREMENT,
      convo_token VARCHAR(32) NOT NULL,
      body text NOT NULL,
      from_agent boolean NOT NULL,
      created_at datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
      PRIMARY KEY (id)
    );
    CREATE TABLE $agents_table (
      id mediumint(9) NOT NULL AUTO_INCREMENT,
      name VARCHAR(32) NOT NULL,
      avatar_url VARCHAR(255) NOT NULL,
      created_at datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
      updated_at datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
      PRIMARY KEY (id)
    );";

    require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
    dbDelta( $sql );
    add_option( "livelychatsupport_db_version", "1.0" );
  }
  
  function LivelyChatSupport_uninstallation() {
    global $wpdb;
    
    $convos_table = $wpdb->prefix . "livelychatsupport_convos";
    $messages_table = $wpdb->prefix . "livelychatsupport_messages";
    $agents_table = $wpdb->prefix . "livelychatsupport_agents";
    
  	$wpdb->query("DROP TABLE IF EXISTS $convos_table");
  	$wpdb->query("DROP TABLE IF EXISTS $messages_table");
  	$wpdb->query("DROP TABLE IF EXISTS $agents_table");
    
    delete_option("livelychatsupport_db_version");
    delete_option("livelychatsupport_online");
    delete_option("livelychatsupport_colour");
    delete_option("livelychatsupport_position");
    delete_option("livelychatsupport_offline_thanks");
    delete_option("livelychatsupport_cta_online_text");
    delete_option("livelychatsupport_cta_offline_text");
    delete_option("livelychatsupport_cta_online_image");
    delete_option("livelychatsupport_cta_online_image_offset_y");
    delete_option("livelychatsupport_cta_online_image_offset_x");
    delete_option("livelychatsupport_cta_offline_image");
    delete_option("livelychatsupport_cta_offline_image_offset_y");
    delete_option("livelychatsupport_cta_offline_image_offset_x");
    delete_option("livelychatsupport_email");
    delete_option("livelychatsupport_name");
  }
  
?>