<?php
  
  function LivelyChatSupport_convo($token) {
    global $wpdb;
    $convos_table = $wpdb->prefix . "livelychatsupport_convos";
    return $wpdb->get_row("SELECT * FROM $convos_table WHERE token='$token'");
  }
  
  function LivelyChatSupport_agent() {
    global $wpdb;
    $agents_table = $wpdb->prefix . "livelychatsupport_agents";
    $agent = $wpdb->get_row("SELECT * FROM $agents_table LIMIT 1");
    return $agent;
  }
  
  function LivelyChatSupport_messages($convo_token, $sort) {
    global $wpdb;
    $messages_table = $wpdb->prefix . "livelychatsupport_messages";
    $messages = $wpdb->get_results("SELECT * FROM $messages_table WHERE convo_token = '$convo_token' ORDER BY created_at $sort");
    return $messages;
  }
  
  function LivelyChatSupport_set_cookies() {
    if (!isset($_COOKIE["livelychatsupport_convo_open"])) {
      $_COOKIE["livelychatsupport_convo_open"] = "false";
      setcookie("livelychatsupport_convo_open", $_COOKIE["livelychatsupport_convo_open"], mktime(0, 0, 0, 12, 31, date("Y") + 2), "/");
    }

    if (!isset($_COOKIE["livelychatsupport_convo_token"])) {
      $_COOKIE["livelychatsupport_convo_token"] = md5(uniqid(rand(), true));
      setcookie("livelychatsupport_convo_token", $_COOKIE["livelychatsupport_convo_token"], mktime(0, 0, 0, 12, 31, date("Y") + 2), "/");
    }
  }
  
  function LivelyChatSupport_state($open, $offline, $chatting){
    $classes = array();
  
    if ($offline == true) {
      array_push($classes, "offline");
    }
    else
    {
      if ($chatting == true)
      {
        array_push($classes, "chatting");
      }
    }
  
    if ($open == true) {
      array_push($classes, "open"); 
    }
    
    return $classes;
  }

  function LivelyChatSupport_frontend_footer()
  {
    global $wpdb;
    $convos_table = $wpdb->prefix . "livelychatsupport_convos";
  
    wp_register_style( "LivelyChatSupport-chatbox-reset", plugins_url( "lively-chat-support/chatbox/css/reset.css" ) );
    wp_register_style( "LivelyChatSupport-chatbox-style", plugins_url( "lively-chat-support/chatbox/css/style.css" ) );
    wp_register_script( "LivelyChatSupport-chatbox-script", plugins_url( "lively-chat-support/chatbox/js/chatbox.js" ) );
    
    wp_enqueue_style( array("LivelyChatSupport-chatbox-reset", "LivelyChatSupport-chatbox-style", "LivelyChatSupport-chatbox-colours") );
    wp_enqueue_script( array("jquery", "LivelyChatSupport-chatbox-script") );
  
    $livelychatsupport = LivelyChatSupport_details();
    $convo = LivelyChatSupport_convo($_COOKIE["livelychatsupport_convo_token"]);
    
    if ((isset($_COOKIE["livelychatsupport_convo_open"]) && $_COOKIE["livelychatsupport_convo_open"] == "true") || LIVELYCHATSUPPORT_ADMIN == true) { $livelychatsupport_open = true; }
    if ($livelychatsupport["online"] == "offline") { $livelychatsupport_offline = true; }
  
    $referrers = $convo ? json_decode($convo->referrers) : array();
    array_push($referrers, "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']);

    if (LIVELYCHATSUPPORT_ADMIN == false && isset($_COOKIE["livelychatsupport_convo_token"]))
    {
      if ($convo) {
        $wpdb->update( 
        	$convos_table, 
        	array(
            "referrers" => json_encode($referrers),
            "updated_at" => date("Y-m-d H:i:s"),
            "last_seen" => date("Y-m-d H:i:s")
        	),
          array(
            "token" => $_COOKIE["livelychatsupport_convo_token"]
          )
        );
      } else if (!is_admin()) {
        $ch = curl_init("http://ip-api.com/json");
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $geo = json_decode(curl_exec($ch));
        
        if ($geo)
        {
        	$args = array( 
            "token" => $_COOKIE["livelychatsupport_convo_token"],
            "referrers" => json_encode($referrers),
            "ip" => $_SERVER["REMOTE_ADDR"],
            "user_agent" => $_SERVER['HTTP_USER_AGENT'],
            "city" => $geo->city,
            "province" => $geo->regionName,
            "country" => $geo->country,
            "country_code" => $geo->countryCode,
            "province_code" => $geo->region,
            "latitude" => $geo->lat,
            "longitude" => $geo->lon,
            "created_at" => date("Y-m-d H:i:s"),
            "updated_at" => date("Y-m-d H:i:s"),
            "last_seen" => date("Y-m-d H:i:s")
        	);
        }
        else
        {
        	$args = array( 
            "token" => $_COOKIE["livelychatsupport_convo_token"],
            "referrers" => json_encode($referrers),
            "ip" => $_SERVER["REMOTE_ADDR"],
            "user_agent" => $_SERVER['HTTP_USER_AGENT'],
            "created_at" => date("Y-m-d H:i:s"),
            "updated_at" => date("Y-m-d H:i:s"),
            "last_seen" => date("Y-m-d H:i:s")
        	);
        }
    
        $wpdb->insert( 
        	$convos_table, 
        	$args
        );
      
        $convo = (object) array( "name" => "", "email" => "", "token" => $_COOKIE["livelychatsupport_convo_token"] );
      }
      
      if ($livelychatsupport["online"] != "hidden" && $livelychatsupport["subscriber_email"] != "" && $livelychatsupport["subscriber_name"] != "") {
        include_once(LIVELYCHATSUPPORT_ROOT. "/chatbox/includes/structure.php");
      }
    }
  }
  
  function LivelyChatSupport_create_message() {
    if (isset($_POST["convo_token"]) && isset($_POST["body"]))
    {
      global $wpdb;
      $body = filter_var($_POST["body"], FILTER_SANITIZE_STRING);
      $from_agent = isset($_POST["from_agent"]) ? 1 : 0;
      $convo = LivelyChatSupport_convo($_POST["convo_token"]);
      $now = date("Y-m-d H:i:s");
      
      if ($convo)
      {
        $message = $wpdb->insert( 
          $wpdb->prefix . "livelychatsupport_messages", 
          array(
            "convo_token" => $convo->token,
            "body" => $body,
            "from_agent" => $from_agent,
            "created_at" => $now
          )
        );
        
        if ($from_agent == 1) {
          $details = array(
            "messages_count" => $convo->messages_count + 1,
            "updated_at" => $now
          );
        } else {
          $details = array(
            "pending" => true,
            "messages_count" => $convo->messages_count + 1,
            "updated_at" => $now,
            "last_seen" => $now
          );
        }
      
        $wpdb->update( 
          $wpdb->prefix . "livelychatsupport_convos", 
          $details,
          array(
            "token" => $convo->token
          )
        );
      }
      die(json_encode(array("success" => true)));
    }
  }
  
  function LivelyChatSupport_subscribe() {
    if (isset($_POST["convo_token"]) && isset($_POST["Email"]) && isset($_POST["Name"])) {
      global $wpdb;
      $livelychatsupport = LivelyChatSupport_details();
      $convo = LivelyChatSupport_convo($_POST["convo_token"]);
      $convos_table = $wpdb->prefix . "livelychatsupport_convos";

      if (filter_var($_POST["Email"], FILTER_VALIDATE_EMAIL) && isset($_POST["Name"]))
      {
        $name = filter_var($_POST["Name"], FILTER_SANITIZE_STRING);
        $email = filter_var($_POST["Email"], FILTER_SANITIZE_EMAIL);
    
        $wpdb->update( 
        	$convos_table, 
        	array(
        	  "name" => $name,
            "email" => $email
        	),
          array(
            "token" => $_COOKIE["livelychatsupport_convo_token"]
          )
        );
    
        if ($livelychatsupport["online"] == "offline")
        {
          $_COOKIE["livelychatsupport_convo_open"] = "false";
          setcookie("livelychatsupport_convo_open", "false", mktime(0, 0, 0, 12, 31, date("Y") + 2), "/");
      
          $msg = "<table>";
      		foreach ($_POST as $field => $value)
      		{
            $value = filter_var($value, FILTER_SANITIZE_STRING);
      			$msg .= "
              <tr>
                <td style=\"text-align:right; \">
                  <strong>$field:</strong>
                </td>
                <td>$value</td>
              </tr>";
      		}
      		$msg .= "</table>";

      		$to = "$livelychatsupport[subscriber_name] <$livelychatsupport[subscriber_email]>";

      		$subject = "Website Form - $name";
      		$headers = "MIME-Version: 1.0" . "\r\n";
      		$headers .= "Content-type: text/html; charset=iso-8859-1" . "\r\n";
      		$headers .= "From: $name <$email>" . "\r\n";

      		mail($to, $subject, $msg, $headers);
        }
      }

    }
    
    die(json_encode(array("success" => true)));
  }
  
?>